import java.io.*;

public class Eccezioni
{
	public static void main(String[] argv) throws MyException
	{
		try
		{
			(new Eccezioni()).exec(argv);
			System.out.println("Flusso normale del programma");
		}
		catch(java.io.FileNotFoundException fnfe)
		{
			System.out.println("Handler fnfe in main");
			fnfe.printStackTrace();
			RuntimeException re = new RuntimeException("Questa non te la aspetti");
			re.initCause(fnfe);
			throw re;
		}
		finally
		{
			System.out.println("Comunque anche il main ha diritto di dire qualcosa");
		}
	}

	public void exec(String[] argv) throws java.io.FileNotFoundException, MyException, NullPointerException
	{
		java.io.FileReader fr2 = null;

		try
		{
			fr2 = new FileReader("Eccezioni.java");
		}
		catch(FileNotFoundException fnfe2)
		{
			fnfe2.printStackTrace();
		}

		try
		{
			fr2.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		System.out.println("Programma dimostrativo delle eccezioni");
		try
		{
			if(argv.length > 1)
			{
				throw new RuntimeException("Salve, io sono una RuntimeException");
			}
			System.out.println("Questo non viene eseguito se si lancia l'eccezione");

			java.io.FileReader fr = new java.io.FileReader(argv[0]);
		}
		catch(RuntimeException re)
		{
			System.out.println("Io sono un RuntimeException handler");
		}
		/*
		catch(java.io.FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
		}
		*/
		finally
		{
			System.out.println("Questo viene eseguito sia che ci sia, sia che non ci sia il lancio dell'eccezione");
		}

		if(argv[0].equals("pippo"))
		{
			throw new MyException("E basta con questo pippo!");
		}

	}
}
