package facolta;

import java.util.ArrayList;

public class Facolta
{
	ArrayList<Studente> studenti;
	String nome;

	public Facolta(String n)
	{
		studenti = new ArrayList<Studente>();
		nome = n;
	}

	/**
	* Aggiunge lo studente se non era gia' presente.
	* Torna true se lo studente e' stato aggiunto.
	*/
	public boolean addStudente(Studente s)
	{
		if(!studenti.contains(s))
		{
			studenti.add(new Studente(s));
			//questo non e' normalmente utile o atteso
			s.nome = "zibibbo";
			return true;
		}
		return false;
	}

	/**
	* Aggiunge tutti gli studenti della ArrayList alla facolta' se non erano
	* gia' presenti.
	* Torna true se e' stato aggiunto almeno uno studente;
	*/
	public boolean addStudente(ArrayList<Studente> als)
	{
		boolean retval = false;
		for(Studente s: als)
		{
			retval = retval || addStudente(s);
		}
		return retval;
	}

	public String toString()
	{
		return nome + ": " + studenti.toString();
	}
}
